CREATE TABLE sf_guard_forgot_password (id BIGINT AUTO_INCREMENT, user_id BIGINT NOT NULL, unique_key VARCHAR(255), expires_at DATETIME NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX user_id_idx (user_id), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_group (id BIGINT AUTO_INCREMENT, name VARCHAR(255) UNIQUE, description TEXT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_group_permission (group_id BIGINT, permission_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(group_id, permission_id)) ENGINE = INNODB;
CREATE TABLE sf_guard_permission (id BIGINT AUTO_INCREMENT, name VARCHAR(255) UNIQUE, description TEXT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_remember_key (id BIGINT AUTO_INCREMENT, user_id BIGINT, remember_key VARCHAR(32), ip_address VARCHAR(50), created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX user_id_idx (user_id), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user (id BIGINT AUTO_INCREMENT, first_name VARCHAR(255), last_name VARCHAR(255), id_domaine BIGINT, email_address VARCHAR(255), username VARCHAR(128) NOT NULL, algorithm VARCHAR(128) DEFAULT 'sha1' NOT NULL, salt VARCHAR(128), password VARCHAR(128), is_active TINYINT(1) DEFAULT '1', is_super_admin TINYINT(1) DEFAULT '0', last_login DATETIME, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX is_active_idx_idx (is_active), INDEX id_domaine_idx (id_domaine), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user_group (user_id BIGINT, group_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(user_id, group_id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user_permission (user_id BIGINT, permission_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(user_id, permission_id)) ENGINE = INNODB;
CREATE TABLE tbl_application (id BIGINT AUTO_INCREMENT, application_name VARCHAR(50), application_version VARCHAR(10), application_code VARCHAR(20), created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE tbl_domaine (id BIGINT AUTO_INCREMENT, titre VARCHAR(50) NOT NULL, description TEXT, is_ldap TINYINT(1), ip_ldap VARCHAR(50), base_dc VARCHAR(50), created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, slug VARCHAR(255), UNIQUE INDEX tbl_domaine_sluggable_idx (slug), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE tbl_groupe (id BIGINT AUTO_INCREMENT, titre VARCHAR(50) NOT NULL, description TEXT, id_domaine BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, slug VARCHAR(255), UNIQUE INDEX tbl_groupe_sluggable_idx (slug), INDEX id_domaine_idx (id_domaine), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE tbl_groupeuser (id BIGINT AUTO_INCREMENT, id_groupe BIGINT, id_sfguarduser BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX id_groupe_idx (id_groupe), INDEX id_sfguarduser_idx (id_sfguarduser), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE tbl_session (id BIGINT AUTO_INCREMENT, content TEXT NOT NULL, application_os VARCHAR(50), application_protocole_version VARCHAR(50), application_ip_local VARCHAR(50), application_ip_public VARCHAR(50), application_hostname VARCHAR(50), application_id BIGINT NOT NULL, application_date DATETIME, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX application_id_idx (application_id), PRIMARY KEY(id)) ENGINE = INNODB;
ALTER TABLE sf_guard_forgot_password ADD CONSTRAINT sf_guard_forgot_password_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_group_permission ADD CONSTRAINT sf_guard_group_permission_permission_id_sf_guard_permission_id FOREIGN KEY (permission_id) REFERENCES sf_guard_permission(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_group_permission ADD CONSTRAINT sf_guard_group_permission_group_id_sf_guard_group_id FOREIGN KEY (group_id) REFERENCES sf_guard_group(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_remember_key ADD CONSTRAINT sf_guard_remember_key_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user ADD CONSTRAINT sf_guard_user_id_domaine_tbl_domaine_id FOREIGN KEY (id_domaine) REFERENCES tbl_domaine(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_group ADD CONSTRAINT sf_guard_user_group_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_group ADD CONSTRAINT sf_guard_user_group_group_id_sf_guard_group_id FOREIGN KEY (group_id) REFERENCES sf_guard_group(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_permission ADD CONSTRAINT sf_guard_user_permission_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_permission ADD CONSTRAINT sf_guard_user_permission_permission_id_sf_guard_permission_id FOREIGN KEY (permission_id) REFERENCES sf_guard_permission(id) ON DELETE CASCADE;
ALTER TABLE tbl_groupe ADD CONSTRAINT tbl_groupe_id_domaine_tbl_domaine_id FOREIGN KEY (id_domaine) REFERENCES tbl_domaine(id) ON DELETE CASCADE;
ALTER TABLE tbl_groupeuser ADD CONSTRAINT tbl_groupeuser_id_sfguarduser_sf_guard_user_id FOREIGN KEY (id_sfguarduser) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE tbl_groupeuser ADD CONSTRAINT tbl_groupeuser_id_groupe_tbl_groupe_id FOREIGN KEY (id_groupe) REFERENCES tbl_groupe(id) ON DELETE CASCADE;
ALTER TABLE tbl_session ADD CONSTRAINT tbl_session_application_id_tbl_application_id FOREIGN KEY (application_id) REFERENCES tbl_application(id) ON DELETE CASCADE;
