<?php


class sfGuardUserTable extends PluginsfGuardUserTable
{
   /**
   * Retrieves a sfGuardUser object by username and is_active flag.
   *
   * @param  string  $username The username
   * @param  boolean $isActive The user's status
   *
   * @return sfGuardUser
   */
  public function retrieveByUsernameAdmin($username, $isActive = true, $isSuperAdmin = true)
  {
    $query = Doctrine_Core::getTable('sfGuardUser')->createQuery('u')
      ->where('u.username = ?', $username)
      ->addWhere('u.is_active = ?', $isActive)
      ->addWhere('u.is_super_admin = ?', $isSuperAdmin)
    ;

    return $query->fetchOne();
  }
  public function retrieveByUsernameDomaine($username, $nDomaine, $isActive = true)
  {
    $query = Doctrine_Core::getTable('sfGuardUser')->createQuery('u')
      ->where('u.username = ?', $username)
      ->addWhere('u.is_active = ?', $isActive)
      ->addWhere('u.id_domaine = ?', $nDomaine)
    ;

    return $query->fetchOne();
  }
    public static function getInstance()
    {
        return Doctrine_Core::getTable('sfGuardUser');
    }
    public function getListUser() {

      $oUser = sfContext::getInstance()->getUser();
      $query = $this->createQuery('u');
      $nDomaine =  $oUser->getDomaine();
      //cas super admin
      if ($oUser->hasCredential('admin')) {

        //cas admin domaine
      } elseif ($oUser->hasCredential('admin_domaine')) {
        $query->where('u.id_domaine = ?', $nDomaine);
        //cas resp groupe
      }

      $query->execute();
      return $query;


    }
  public function findUser($pnIdDomaine) {
        $q = $this->createQuery('u');
        $q->addWhere('u.id_domaine = ?', $pnIdDomaine);
        $oUsers = $q->execute();
        $aUser = array();
        foreach ($oUsers as $oUser) {
          $aUser[] = $oUser->getId();
        }

        return $aUser;

  }
}