<?php

/**
 * sfGuardUserAdminForm for admin generators
 *
 * @package    sfDoctrineGuardPlugin
 * @subpackage form
 * @author     Fabien Potencier <fabien.potencier@symfony-project.com>
 * @version    SVN: $Id: sfGuardUserAdminForm.class.php 23536 2009-11-02 21:41:21Z Kris.Wallsmith $
 */
class sfGuardUserAdminForm extends BasesfGuardUserAdminForm
{
  /**
   * @see sfForm
   */
  public function configure()
  {
      parent::configure();
      $oUser = sfContext::getInstance()->getUser();
      if (!$oUser->isSuperAdmin()) {
          unset($this['is_super_admin'], $this['id_domaine']);
          $nDomaine =  $oUser->getDomaine();
          $qGroupDisplay = $this->getGroupDisplayQuery();
          $this->widgetSchema['groups_list'] =  new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'sfGuardGroup',
                                                                                                         'add_empty' => false,
                                                                                                         'query' => $qGroupDisplay));
          $qGroupeClasseDisplay = $this->getGroupeClasseDomaine($nDomaine);
          $this->widgetSchema['tbl_groupe_list'] =  new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'tbl_groupe',
                                                                                                         'add_empty' => false,
                                                                                                         'query' => $qGroupeClasseDisplay));

      }
  }

  public function getGroupDisplayQuery() {
    $query = Doctrine::getTable('sfGuardGroup')->createQuery('g');
    $query->where('g.name <> "admin"');

    return $query;
  }

  public function getGroupeClasseDomaine($pnDomaine) {
    $query = Doctrine::getTable('tbl_groupe')->createQuery('g');
    $query->where('g.id_domaine=?', $pnDomaine);

    return $query;
  }
}
